ClusterResourceSet [addons.cluster.x-k8s.io/v1beta1]

Description
ClusterResourceSet is the Schema for the clusterresourcesets API. For advanced use cases an add-on provider should be used instead.
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

spec is the desired state of ClusterResourceSet.

statusobject

status is the observed state of ClusterResourceSet.

.spec

Description
spec is the desired state of ClusterResourceSet.
Type
object
Required
clusterSelector
PropertyTypeDescription
clusterSelectorobject

clusterSelector is the label selector for Clusters. The Clusters that are selected by this will be the ones affected by this ClusterResourceSet. It must match the Cluster labels. This field is immutable. Label selector cannot be empty.

resourcesarray

resources is a list of Secrets/ConfigMaps where each contains 1 or more resources to be applied to remote clusters.

strategystring

strategy is the strategy to be used during applying resources. Defaults to ApplyOnce. This field is immutable.

.spec.clusterSelector

Description
clusterSelector is the label selector for Clusters. The Clusters that are selected by this will be the ones affected by this ClusterResourceSet. It must match the Cluster labels. This field is immutable. Label selector cannot be empty.
Type
object
PropertyTypeDescription
matchExpressionsarray

matchExpressions is a list of label selector requirements. The requirements are ANDed.

matchLabelsobject

matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.

.spec.clusterSelector.matchExpressions

Description
matchExpressions is a list of label selector requirements. The requirements are ANDed.
Type
array

.spec.clusterSelector.matchExpressions[]

Description
A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
Type
object
Required
keyoperator
PropertyTypeDescription
keystring

key is the label key that the selector applies to.

operatorstring

operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

valuesarray

values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

.spec.clusterSelector.matchExpressions[].values

Description
values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
Type
array

.spec.clusterSelector.matchExpressions[].values[]

Type
string

.spec.clusterSelector.matchLabels

Description
matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
Type
object

.spec.resources

Description
resources is a list of Secrets/ConfigMaps where each contains 1 or more resources to be applied to remote clusters.
Type
array

.spec.resources[]

Description
ResourceRef specifies a resource.
Type
object
Required
kindname
PropertyTypeDescription
kindstring

kind of the resource. Supported kinds are: Secrets and ConfigMaps.

namestring

name of the resource that is in the same namespace with ClusterResourceSet object.

.status

Description
status is the observed state of ClusterResourceSet.
Type
object
PropertyTypeDescription
conditionsarray

conditions defines current state of the ClusterResourceSet.

observedGenerationinteger

observedGeneration reflects the generation of the most recently observed ClusterResourceSet.

v1beta2object

v1beta2 groups all the fields that will be added or modified in ClusterResourceSet's status with the V1Beta2 version.

.status.conditions

Description
conditions defines current state of the ClusterResourceSet.
Type
array

.status.conditions[]

Description
Condition defines an observation of a Cluster API resource operational state.
Type
object
Required
lastTransitionTimestatustype
PropertyTypeDescription
lastTransitionTimestring

lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

messagestring

message is a human readable message indicating details about the transition. This field may be empty.

reasonstring

reason is the reason for the condition's last transition in CamelCase. The specific API may choose whether or not this field is considered a guaranteed API. This field may be empty.

severitystring

severity provides an explicit classification of Reason code, so the users or machines can immediately understand the current situation and act accordingly. The Severity field MUST be set only when Status=False.

statusstring

status of the condition, one of True, False, Unknown.

typestring

type of condition in CamelCase or in foo.example.com/CamelCase. Many .condition.type values are consistent across resources like Available, but because arbitrary conditions can be useful (see .node.status.conditions), the ability to deconflict is important.

.status.v1beta2

Description
v1beta2 groups all the fields that will be added or modified in ClusterResourceSet's status with the V1Beta2 version.
Type
object
PropertyTypeDescription
conditionsarray

conditions represents the observations of a ClusterResourceSet's current state. Known condition types are ResourceSetApplied, Deleting.

.status.v1beta2.conditions

Description
conditions represents the observations of a ClusterResourceSet's current state. Known condition types are ResourceSetApplied, Deleting.
Type
array

.status.v1beta2.conditions[]

Description
Condition contains details for one aspect of the current state of this API Resource.
Type
object
Required
lastTransitionTimemessagereasonstatustype
PropertyTypeDescription
lastTransitionTimestring

lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

messagestring

message is a human readable message indicating details about the transition. This may be an empty string.

observedGenerationinteger

observedGeneration represents the .metadata.generation that the condition was set based upon. For instance, if .metadata.generation is currently 12, but the .status.conditions[x].observedGeneration is 9, the condition is out of date with respect to the current state of the instance.

reasonstring

reason contains a programmatic identifier indicating the reason for the condition's last transition. Producers of specific condition types may define expected values and meanings for this field, and whether the values are considered a guaranteed API. The value should be a CamelCase string. This field may not be empty.

statusstring

status of the condition, one of True, False, Unknown.

typestring

type of condition in CamelCase or in foo.example.com/CamelCase.

API Endpoints

The following API endpoints are available:

  • /apis/addons.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusterresourcesets
    • DELETE: delete collection of ClusterResourceSet
    • GET: list objects of kind ClusterResourceSet
    • POST: create a new ClusterResourceSet
  • /apis/addons.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusterresourcesets/{name}
    • DELETE: delete the specified ClusterResourceSet
    • GET: read the specified ClusterResourceSet
    • PATCH: partially update the specified ClusterResourceSet
    • PUT: replace the specified ClusterResourceSet
  • /apis/addons.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusterresourcesets/{name}/status
    • GET: read status of the specified ClusterResourceSet
    • PATCH: partially update status of the specified ClusterResourceSet
    • PUT: replace status of the specified ClusterResourceSet

/apis/addons.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusterresourcesets

HTTP method
DELETE
Description
delete collection of ClusterResourceSet
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind ClusterResourceSet
HTTP responses
HTTP codeResponse body
200 - OKClusterResourceSetList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new ClusterResourceSet
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyClusterResourceSet schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKClusterResourceSet schema
201 - CreatedClusterResourceSet schema
202 - AcceptedClusterResourceSet schema
401 - UnauthorizedEmpty

/apis/addons.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusterresourcesets/{name}

HTTP method
DELETE
Description
delete the specified ClusterResourceSet
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified ClusterResourceSet
HTTP responses
HTTP codeResponse body
200 - OKClusterResourceSet schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified ClusterResourceSet
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKClusterResourceSet schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified ClusterResourceSet
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyClusterResourceSet schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKClusterResourceSet schema
201 - CreatedClusterResourceSet schema
401 - UnauthorizedEmpty

/apis/addons.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusterresourcesets/{name}/status

HTTP method
GET
Description
read status of the specified ClusterResourceSet
HTTP responses
HTTP codeResponse body
200 - OKClusterResourceSet schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified ClusterResourceSet
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKClusterResourceSet schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified ClusterResourceSet
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyClusterResourceSet schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKClusterResourceSet schema
201 - CreatedClusterResourceSet schema
401 - UnauthorizedEmpty